// (c) 13-Jul-2002 Jouni 'Mr.Spiv' Korhonen
//

#include "gpdef.h"
#include "gpstdlib.h"
//#include "gpgraphic.h"
#include "gpmain.h"
//#include "gpfont.h"

#include <stdlib.h>
#include <string.h>

volatile long* tpal = (long*)0x14a00050;
volatile long* lcdcon1 = (long*)0x14a00000;
volatile long* lcdcon2 = (long*)0x14a00004;
volatile long* lcdcon3 = (long*)0x14a00008;
volatile long* lcdcon4 = (long*)0x14a0000c;
volatile long* lcdcon5 = (long*)0x14a00010;

volatile long* lcdaddr1 = (long*)0x14a00014;
volatile long* lcdaddr2 = (long*)0x14a00018;
volatile long* lcdaddr3 = (long*)0x14a0001c;

volatile long* hwpal = (long*)0x14a00400;

extern unsigned char klonoa;

#include "klonoa.h"

void waitline( int line ) {
	while (line != ((*lcdcon1 >> 18) & 0x1ff) );
}

void GpMain(void *arg)
{
	long scrptru;
	long scrptrl;
	long ptr;
	long keys;
	int x,y;

	unsigned long *dst;
	unsigned long *src;

	for (x = 0; x < 256; x++)
		hwpal[x] = klonoa_Pal[x];

	dst = (unsigned long*)0x0C7B4000;
	src = (unsigned long*)&klonoa;
	src+=2; //skip over .gpg header

	for (x = 0; x < ((480 * 640) / 4); x++)
		*dst++ = *src++;

	// 640x480x8 screen mode, 240 pixel offscreen
	// expects 33MHz HCLK

	*lcdcon1 = ((3 << 8) | (0 << 7) | (3 << 5) | (11 << 1) | (0));
							// CLKVAL=3, VNMODE=0, PNRMODE=TFT, BPPMODE=1011 (8bits), ENDID=0
	*lcdcon2 = ((1 << 24) | (319 << 14) | (2 << 6) | 1);
							// VBPD=1, LINEVAL=319, VFPD=2, VSPW=1
	*lcdcon3 = ((6 << 19) | (239 << 8) | (2));
							// HBPD=6, HOZVAL=239, HFPD=2
	*lcdcon4 = ((0 << 24) | (0 << 16) | (4));
							// PALADDEN=0, ADDVAL=0, HSPW=4
	*lcdcon5 = ((1 << 10) | (1 << 9) | (1 << 8) | (0 << 7) | (0 << 6) | (0 << 4) | (0 << 2) | (1 << 1) | (0));
							// INVVCLK=1, INVVLINE=1, INVVFRAME=1, INVVD=0, INVVDEN=0
							// INVENDLINE=0, ENLEND=0, BSWP=1, HWSWP=0
	*tpal = 0;

	ptr =         (long)0x0C7B4000;
	*lcdaddr1 = ((ptr & 0x0fc00000) >> 1) | ((ptr & 0x3ffffe) >> 1);
	*lcdaddr2 = ((ptr & 0x003ffffe) >> 1) + (240) * (319+1);

	*lcdaddr3 = ((120 << 11) | (120));
							// OFFSIZE=0, PAGEWIDTH=240 halfwords -> 240 pixels

	*lcdcon1 |= 1;	// enable lcd


	scrptru = *lcdaddr1;
	scrptrl = *lcdaddr2;

	x = 0;
	y = 0;

	keys = 0;

	while ((keys & (GPC_VK_FL | GPC_VK_FR)) != (GPC_VK_FL | GPC_VK_FR)) {

		keys = GpKeyGet();

		waitline(2);

		if (keys & GPC_VK_UP)
		{
			if (y < 120)
			{
				*lcdaddr1 += 1;
				*lcdaddr2 += 1;
				y++;
			}
		}


		if (keys & GPC_VK_DOWN)
		{
			if (y > 0)
			{
				*lcdaddr1 -= 1;
				*lcdaddr2 -= 1;
				y--;
			}
		}

		if (keys & GPC_VK_RIGHT)
		{
			if (x < 320)
			{
				*lcdaddr1 += 240;
				*lcdaddr2 += 240;
				x++;
			}
		}

		if (keys & GPC_VK_LEFT)
		{
			if (x > 0)
			{
				*lcdaddr1 -= 240;
				*lcdaddr2 -= 240;
				x--;
			}
		}

		waitline(1);
	}

	*tpal = 0x0001ffff;
	// reboot..

	while ((GpKeyGet() & (GPC_VK_SELECT | GPC_VK_START)) != (GPC_VK_SELECT | GPC_VK_START));
	GpAppExit();
}
